unit wmtest;

interface

uses
  x, xlib, xutil, xatom, sysutils, ctypes;

var
  display: PDisplay;
  root: TWindow;
  wm_running: Boolean = False;

implementation

procedure check_wm_running;
var
  wm_check_atom: TAtom;
  wm_check_win: TWindow;
  actual_type: TAtom;
  actual_format: cint;
  nitems, bytes_after: culong;
  data: PWindow;
begin
  wm_check_atom := XInternAtom(display, '_NET_SUPPORTING_WM_CHECK', True);
  if wm_check_atom = None then Exit;

  if XGetWindowProperty(display, root, wm_check_atom, 0, 1, False, XA_WINDOW,
                        @actual_type, @actual_format, @nitems, @bytes_after, @data) = Success then
  begin
    if data <> nil then
    begin
      wm_running := True;
      XFree(data);
    end;
  end;
end;

begin
  display := XOpenDisplay(nil);
  if display = nil then
  begin
    Writeln('Не удалось открыть дисплей');
    Halt(1);
  end;

  root := DefaultRootWindow(display);

  check_wm_running;
  if wm_running then
  begin
    Writeln('Другой оконный менеджер уже запущен');
//    XCloseDisplay(display);
//    Halt(1);
  end;

  XCloseDisplay(display);
end.